import { IDIService } from "./IDIService";
import { CancelationTokenSource } from './CancelationTokenSource';
import { ILoggerService } from './Services/Logging/ILoggerService';
export declare class DependencyContainer {
    private static _instance;
    private _services;
    private _serviceRegistrationEvent;
    static Log?: ILoggerService;
    static IsInitialized: boolean;
    static get Instance(): DependencyContainer;
    RegisterService(service: IDIService): void;
    GetService<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }): T;
    GetServiceAsync<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }, token?: CancelationTokenSource): Promise<T>;
    GetServiceWithTimeoutAsync<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }, timeout: number): Promise<T>;
}
