import { ITypedEvent } from "../../TypedEvent";
import { IDeviceTaskTypeInfo, IDeviceResponseTypeInfo } from "./IDevice";
import { ChannelConfigurations, IDeviceChannel, TaskExecution } from "./IDeviceChannel";
import { IDeviceState, IDeviceStateData } from "./IDeviceState";
import { IDeviceTask } from "./IDeviceTask";
import { DeviceTaskExecutionResult } from "./TaskExecutionResult";
export declare class DeviceChannel implements IDeviceChannel {
    private _number;
    private _name;
    private _iconName;
    private _states;
    private _mode;
    private _channelGroups;
    private _isHidden;
    private _availableTasksTypes;
    private _availableResponseTypes;
    private _onTasksExecutionChangedEvent;
    get Number(): number;
    set Number(value: number);
    get Name(): string;
    set Name(value: string);
    get IconName(): string;
    set IconName(value: string);
    get States(): IDeviceState<IDeviceStateData>[];
    set States(value: IDeviceState<IDeviceStateData>[]);
    set State(value: IDeviceState<IDeviceStateData>);
    get Mode(): ChannelConfigurations;
    set Mode(value: ChannelConfigurations);
    get ChannelGroups(): string[];
    set ChannelGroups(value: string[]);
    get IsHidden(): boolean;
    set IsHidden(value: boolean);
    get AvailableTaskTypes(): IDeviceTaskTypeInfo[];
    set AvailableTaskTypes(value: IDeviceTaskTypeInfo[]);
    get AvailableResponseTypes(): IDeviceResponseTypeInfo[];
    set AvailableResponseTypes(value: IDeviceResponseTypeInfo[]);
    OnTasksExecutionChangeEvent(): ITypedEvent<TaskExecution>;
    ExecuteTaskAsync(task: IDeviceTask): Promise<DeviceTaskExecutionResult>;
}
