import { IDIService } from '../../IDIService';
import { ITypedEvent } from '../../TypedEvent';
import { IDevice, DeviceTasksInfo } from './IDevice';
import { IDevicesService } from './IDevicesService';
import { IDeviceState, StateReliability } from './IDeviceState';
export declare class DevicesService implements IDIService, IDevicesService {
    private _devices;
    private _serviceName;
    private _onDevicesTasksChangedEvent;
    private _onDeviceFoundEvent;
    private _onDeviceRegisteredEvent;
    private _onDeviceRemovedEvent;
    private _onDeviceStateChangedEvent;
    private _connection;
    private _fastStatesSync;
    constructor();
    GetCurrentlyRunningTaksAsync(): Promise<void>;
    ParseDeviceTaskInfo(tasks: string[]): void;
    MapApiDeviceStateToDeviceState(device: IDevice, state: DeviceStateChangedObject): IDeviceState<any> | null;
    GetServiceName(): string;
    SyncDevicesStatesAsync(): Promise<boolean>;
    OnDevicesTasksExecutionChangeEvent(): ITypedEvent<DeviceTasksInfo[]>;
    OnDeviceStateChangedEvent(): ITypedEvent<[Device: IDevice, State: IDeviceState<any>]>;
    OnDeviceRegisteredEvent(): ITypedEvent<IDevice>;
    OnDeviceRemovedEvent(): ITypedEvent<IDevice>;
    OnDeviceFoundEvent(): ITypedEvent<IDevice>;
    private MapApiDevices;
    GetDevicesAsync(): Promise<IDevice[]>;
    GetDevice(guid: string): IDevice | undefined;
    FindDevicesAsync(): Promise<void>;
    StopSearchingForDevices(): Promise<void>;
    RegisterDeviceAsync(device: IDevice): Promise<void>;
    RemoveDeviceAsync(device: IDevice): Promise<void>;
}
export declare class DeviceStateChangedObject {
    DeviceGuid: string;
    state: DeviceStateObject;
    Type: number;
    DataType: string;
}
export declare class DeviceStateObject {
    Channel: number;
    StateReliability: StateReliability;
}
