var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { DeviceResponseType } from "./IDevice";
import { nameof } from 'ts-simple-nameof';
var DeviceState = (function () {
    function DeviceState() {
        this._type = "";
        this._data = null;
        this._typeAsEnum = DeviceResponseType.Unknown;
    }
    Object.defineProperty(DeviceState.prototype, "Data", {
        get: function () {
            return this._data;
        },
        set: function (value) {
            this._data = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceState.prototype, "Type", {
        get: function () {
            return this._type;
        },
        set: function (value) {
            this._type = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceState.prototype, "TypeAsEnum", {
        get: function () {
            return this._typeAsEnum;
        },
        set: function (value) {
            this._typeAsEnum = value;
        },
        enumerable: false,
        configurable: true
    });
    return DeviceState;
}());
export { DeviceState };
export var StateReliability;
(function (StateReliability) {
    StateReliability[StateReliability["Confident"] = 0] = "Confident";
    StateReliability[StateReliability["Unconfident"] = 1] = "Unconfident";
})(StateReliability || (StateReliability = {}));
var ChannelOnOffDeviceState = (function (_super) {
    __extends(ChannelOnOffDeviceState, _super);
    function ChannelOnOffDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.ChannelOnOffState;
        _this.Type = nameof(ChannelOnOffState);
        _this.Data = state.state;
        return _this;
    }
    return ChannelOnOffDeviceState;
}(DeviceState));
export { ChannelOnOffDeviceState };
var ChannelOnOffState = (function () {
    function ChannelOnOffState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = ChannelOnOffStateEnum.Unknown;
    }
    return ChannelOnOffState;
}());
export { ChannelOnOffState };
export var ChannelOnOffStateEnum;
(function (ChannelOnOffStateEnum) {
    ChannelOnOffStateEnum[ChannelOnOffStateEnum["On"] = 0] = "On";
    ChannelOnOffStateEnum[ChannelOnOffStateEnum["Off"] = 1] = "Off";
    ChannelOnOffStateEnum[ChannelOnOffStateEnum["Unknown"] = 2] = "Unknown";
})(ChannelOnOffStateEnum || (ChannelOnOffStateEnum = {}));
var DoorBellDeviceState = (function (_super) {
    __extends(DoorBellDeviceState, _super);
    function DoorBellDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.DoorBellState;
        _this.Type = nameof(DoorBellState);
        _this.Data = state.state;
        return _this;
    }
    return DoorBellDeviceState;
}(DeviceState));
export { DoorBellDeviceState };
var DoorBellState = (function () {
    function DoorBellState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = DoorBellStateEnum.Relased;
    }
    return DoorBellState;
}());
export { DoorBellState };
export var DoorBellStateEnum;
(function (DoorBellStateEnum) {
    DoorBellStateEnum[DoorBellStateEnum["Pressed"] = 0] = "Pressed";
    DoorBellStateEnum[DoorBellStateEnum["Relased"] = 1] = "Relased";
    DoorBellStateEnum[DoorBellStateEnum["PressedAndRelased"] = 2] = "PressedAndRelased";
})(DoorBellStateEnum || (DoorBellStateEnum = {}));
var ReedPositionDeviceState = (function (_super) {
    __extends(ReedPositionDeviceState, _super);
    function ReedPositionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.ReedPosition;
        _this.Type = nameof(ReedPostionState);
        _this.Data = state.state;
        return _this;
    }
    return ReedPositionDeviceState;
}(DeviceState));
export { ReedPositionDeviceState };
var ReedPostionState = (function () {
    function ReedPostionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = false;
    }
    return ReedPostionState;
}());
export { ReedPostionState };
var BlindPositionDeviceState = (function (_super) {
    __extends(BlindPositionDeviceState, _super);
    function BlindPositionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BlindPosition;
        _this.Type = nameof(BlindPostionState);
        _this.Data = state.state;
        return _this;
    }
    return BlindPositionDeviceState;
}(DeviceState));
export { BlindPositionDeviceState };
var BlindPostionState = (function () {
    function BlindPostionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Position = 0;
        this.RawPosition = 0;
    }
    return BlindPostionState;
}());
export { BlindPostionState };
var RemoteButtonDeviceState = (function (_super) {
    __extends(RemoteButtonDeviceState, _super);
    function RemoteButtonDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.RemoteButtonState;
        _this.Type = nameof(RemoteButtonState);
        _this.Data = state.state;
        return _this;
    }
    return RemoteButtonDeviceState;
}(DeviceState));
export { RemoteButtonDeviceState };
var RemoteButtonState = (function () {
    function RemoteButtonState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = RemoteButtonStateEnum.Relased;
    }
    return RemoteButtonState;
}());
export { RemoteButtonState };
export var RemoteButtonStateEnum;
(function (RemoteButtonStateEnum) {
    RemoteButtonStateEnum[RemoteButtonStateEnum["Pressed"] = 1] = "Pressed";
    RemoteButtonStateEnum[RemoteButtonStateEnum["Relased"] = 2] = "Relased";
    RemoteButtonStateEnum[RemoteButtonStateEnum["PressedAndRelased"] = 3] = "PressedAndRelased";
})(RemoteButtonStateEnum || (RemoteButtonStateEnum = {}));
var LightColorDeviceState = (function (_super) {
    __extends(LightColorDeviceState, _super);
    function LightColorDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.LightColor;
        _this.Type = nameof(LightColorState);
        _this.Data = state.state;
        return _this;
    }
    return LightColorDeviceState;
}(DeviceState));
export { LightColorDeviceState };
var LightColorState = (function () {
    function LightColorState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.R = 0;
        this.G = 0;
        this.B = 0;
    }
    return LightColorState;
}());
export { LightColorState };
var LightWarmthDeviceState = (function (_super) {
    __extends(LightWarmthDeviceState, _super);
    function LightWarmthDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.LightWarmth;
        _this.Type = nameof(LightWarmthState);
        _this.Data = state.state;
        return _this;
    }
    return LightWarmthDeviceState;
}(DeviceState));
export { LightWarmthDeviceState };
var LightWarmthState = (function () {
    function LightWarmthState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Temperature = 0;
    }
    return LightWarmthState;
}());
export { LightWarmthState };
var LightBrightnessDeviceState = (function (_super) {
    __extends(LightBrightnessDeviceState, _super);
    function LightBrightnessDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.LightBrightness;
        _this.Type = nameof(LightBrightnessState);
        _this.Data = state.state;
        return _this;
    }
    return LightBrightnessDeviceState;
}(DeviceState));
export { LightBrightnessDeviceState };
var LightBrightnessState = (function () {
    function LightBrightnessState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Brightness = 0;
    }
    return LightBrightnessState;
}());
export { LightBrightnessState };
var MeasuredTemperatureDeviceState = (function (_super) {
    __extends(MeasuredTemperatureDeviceState, _super);
    function MeasuredTemperatureDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.MeasuredTemperature;
        _this.Type = nameof(MeasuredTemperatureState);
        _this.Data = state.state;
        return _this;
    }
    return MeasuredTemperatureDeviceState;
}(DeviceState));
export { MeasuredTemperatureDeviceState };
var MeasuredTemperatureState = (function () {
    function MeasuredTemperatureState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Temperature = 0;
        this.Type = MeasuredTemperatureTypeEnum.InsideTemperature;
    }
    return MeasuredTemperatureState;
}());
export { MeasuredTemperatureState };
var MeasuredTemperatureTypeEnum;
(function (MeasuredTemperatureTypeEnum) {
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["AirTemperature"] = 0] = "AirTemperature";
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["InsideTemperature"] = 1] = "InsideTemperature";
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["OutsideTemperature"] = 2] = "OutsideTemperature";
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["FloorTemperature"] = 3] = "FloorTemperature";
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["SafetyTemperature"] = 4] = "SafetyTemperature";
    MeasuredTemperatureTypeEnum[MeasuredTemperatureTypeEnum["SetTemperature"] = 5] = "SetTemperature";
})(MeasuredTemperatureTypeEnum || (MeasuredTemperatureTypeEnum = {}));
var BatteryDeviceState = (function (_super) {
    __extends(BatteryDeviceState, _super);
    function BatteryDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BatteryState;
        _this.Type = nameof(BatteryState);
        _this.Data = state.state;
        return _this;
    }
    return BatteryDeviceState;
}(DeviceState));
export { BatteryDeviceState };
var BatteryState = (function () {
    function BatteryState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = BatteryStateEnum.Half;
        this.Percentage = -1;
    }
    return BatteryState;
}());
export { BatteryState };
export var BatteryStateEnum;
(function (BatteryStateEnum) {
    BatteryStateEnum[BatteryStateEnum["Full"] = 0] = "Full";
    BatteryStateEnum[BatteryStateEnum["Empty"] = 1] = "Empty";
    BatteryStateEnum[BatteryStateEnum["Half"] = 2] = "Half";
    BatteryStateEnum[BatteryStateEnum["Percentage"] = 3] = "Percentage";
    BatteryStateEnum[BatteryStateEnum["Low"] = 4] = "Low";
    BatteryStateEnum[BatteryStateEnum["ExternalPower"] = 5] = "ExternalPower";
})(BatteryStateEnum || (BatteryStateEnum = {}));
var MeasuredBrightnessDeviceState = (function (_super) {
    __extends(MeasuredBrightnessDeviceState, _super);
    function MeasuredBrightnessDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.MeasuredBrightness;
        _this.Type = nameof(MeasuredBrightnessState);
        _this.Data = state.state;
        return _this;
    }
    return MeasuredBrightnessDeviceState;
}(DeviceState));
export { MeasuredBrightnessDeviceState };
var MeasuredBrightnessState = (function () {
    function MeasuredBrightnessState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Brightness = 0;
    }
    return MeasuredBrightnessState;
}());
export { MeasuredBrightnessState };
var MeasuredEnergyDeviceState = (function (_super) {
    __extends(MeasuredEnergyDeviceState, _super);
    function MeasuredEnergyDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.MeasuredEnergy;
        _this.Type = nameof(MeasuredEnergyState);
        _this.Data = state.state;
        return _this;
    }
    return MeasuredEnergyDeviceState;
}(DeviceState));
export { MeasuredEnergyDeviceState };
var MeasuredEnergyState = (function () {
    function MeasuredEnergyState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Voltage = 0;
        this.Current = 0;
        this.PhaseShift = 0;
        this.ActivePower = 0;
        this.ReactivePower = 0;
        this.ApparentPower = 0;
        this.PowerFactor = 0;
        this.ActiveEnergy = 0;
        this.ReactiveEnergy = 0;
        this.Frequency = 0;
    }
    return MeasuredEnergyState;
}());
export { MeasuredEnergyState };
var MeasuredDistanceDeviceState = (function (_super) {
    __extends(MeasuredDistanceDeviceState, _super);
    function MeasuredDistanceDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.MeasuredDistance;
        _this.Type = nameof(MeasuredDistanceState);
        _this.Data = state.state;
        return _this;
    }
    return MeasuredDistanceDeviceState;
}(DeviceState));
export { MeasuredDistanceDeviceState };
var MeasuredDistanceState = (function () {
    function MeasuredDistanceState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Distance = 0;
        this.DetectedObject = DetectedObjectStateEnum.No;
    }
    return MeasuredDistanceState;
}());
export { MeasuredDistanceState };
export var DetectedObjectStateEnum;
(function (DetectedObjectStateEnum) {
    DetectedObjectStateEnum[DetectedObjectStateEnum["No"] = 0] = "No";
    DetectedObjectStateEnum[DetectedObjectStateEnum["Yes"] = 1] = "Yes";
})(DetectedObjectStateEnum || (DetectedObjectStateEnum = {}));
var MovementSensorDeviceState = (function (_super) {
    __extends(MovementSensorDeviceState, _super);
    function MovementSensorDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.MovementSensorState;
        _this.Type = nameof(MovementSensorState);
        _this.Data = state.state;
        return _this;
    }
    return MovementSensorDeviceState;
}(DeviceState));
export { MovementSensorDeviceState };
var MovementSensorState = (function () {
    function MovementSensorState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Intensity = 0;
        this.Movement = MovementStateEnum.No;
    }
    return MovementSensorState;
}());
export { MovementSensorState };
export var MovementStateEnum;
(function (MovementStateEnum) {
    MovementStateEnum[MovementStateEnum["No"] = 0] = "No";
    MovementStateEnum[MovementStateEnum["Yes"] = 1] = "Yes";
})(MovementStateEnum || (MovementStateEnum = {}));
var BlindRemoteButtonDeviceState = (function (_super) {
    __extends(BlindRemoteButtonDeviceState, _super);
    function BlindRemoteButtonDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BlindRemoteButtonState;
        _this.Type = nameof(BlindRemoteButtonState);
        _this.Data = state.state;
        return _this;
    }
    return BlindRemoteButtonDeviceState;
}(DeviceState));
export { BlindRemoteButtonDeviceState };
var BlindRemoteButtonState = (function () {
    function BlindRemoteButtonState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = BlindRemoteButtonStateEnum.StopReleased;
    }
    return BlindRemoteButtonState;
}());
export { BlindRemoteButtonState };
export var BlindRemoteButtonStateEnum;
(function (BlindRemoteButtonStateEnum) {
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["OpenPressed"] = 1] = "OpenPressed";
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["OpenReleased"] = 2] = "OpenReleased";
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["StopPressed"] = 3] = "StopPressed";
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["StopReleased"] = 4] = "StopReleased";
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["ClosePressed"] = 5] = "ClosePressed";
    BlindRemoteButtonStateEnum[BlindRemoteButtonStateEnum["CloseReleased"] = 6] = "CloseReleased";
})(BlindRemoteButtonStateEnum || (BlindRemoteButtonStateEnum = {}));
var FacadeRemoteButtonDeviceState = (function (_super) {
    __extends(FacadeRemoteButtonDeviceState, _super);
    function FacadeRemoteButtonDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.FacadeRemoteButtonState;
        _this.Type = nameof(FacadeRemoteButtonState);
        _this.Data = state.state;
        return _this;
    }
    return FacadeRemoteButtonDeviceState;
}(DeviceState));
export { FacadeRemoteButtonDeviceState };
var FacadeRemoteButtonState = (function () {
    function FacadeRemoteButtonState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = FacadeRemoteButtonStateEnum.StopReleased;
    }
    return FacadeRemoteButtonState;
}());
export { FacadeRemoteButtonState };
export var FacadeRemoteButtonStateEnum;
(function (FacadeRemoteButtonStateEnum) {
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["OpenPressed"] = 1] = "OpenPressed";
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["OpenReleased"] = 2] = "OpenReleased";
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["StopPressed"] = 3] = "StopPressed";
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["StopReleased"] = 4] = "StopReleased";
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["ClosePressed"] = 5] = "ClosePressed";
    FacadeRemoteButtonStateEnum[FacadeRemoteButtonStateEnum["CloseReleased"] = 6] = "CloseReleased";
})(FacadeRemoteButtonStateEnum || (FacadeRemoteButtonStateEnum = {}));
var SignalStrenghtDeviceState = (function (_super) {
    __extends(SignalStrenghtDeviceState, _super);
    function SignalStrenghtDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.SignalStrength;
        _this.Type = nameof(SignalStrenghtState);
        _this.Data = state.state;
        return _this;
    }
    return SignalStrenghtDeviceState;
}(DeviceState));
export { SignalStrenghtDeviceState };
var SignalStrenghtState = (function () {
    function SignalStrenghtState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Quality = LinkQualityEnum.Unknown;
        this.MeasurementTime = "";
        this.DidLastTaskSucceded = false;
        this.Percentage = 0;
        this.SuccededExecutionsPercentage = 0;
        this.SuccededTransmissionsPercentage = 0;
    }
    return SignalStrenghtState;
}());
export { SignalStrenghtState };
export var LinkQualityEnum;
(function (LinkQualityEnum) {
    LinkQualityEnum[LinkQualityEnum["Unknown"] = 0] = "Unknown";
    LinkQualityEnum[LinkQualityEnum["Excellent"] = 1] = "Excellent";
    LinkQualityEnum[LinkQualityEnum["Good"] = 2] = "Good";
    LinkQualityEnum[LinkQualityEnum["Acceptable"] = 3] = "Acceptable";
    LinkQualityEnum[LinkQualityEnum["Low"] = 4] = "Low";
    LinkQualityEnum[LinkQualityEnum["Terrible"] = 5] = "Terrible";
    LinkQualityEnum[LinkQualityEnum["NoLink"] = 6] = "NoLink";
})(LinkQualityEnum || (LinkQualityEnum = {}));
var GatePositionDeviceState = (function (_super) {
    __extends(GatePositionDeviceState, _super);
    function GatePositionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.GatePosition;
        _this.Type = nameof(GatePositionState);
        _this.Data = state.state;
        return _this;
    }
    return GatePositionDeviceState;
}(DeviceState));
export { GatePositionDeviceState };
var GatePositionState = (function () {
    function GatePositionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.PositionType = GatePositionTypeEnum.Unknown;
        this.Position = 0;
    }
    return GatePositionState;
}());
export { GatePositionState };
export var GatePositionTypeEnum;
(function (GatePositionTypeEnum) {
    GatePositionTypeEnum[GatePositionTypeEnum["Unknown"] = 0] = "Unknown";
    GatePositionTypeEnum[GatePositionTypeEnum["Open"] = 1] = "Open";
    GatePositionTypeEnum[GatePositionTypeEnum["PartiallyOpen"] = 2] = "PartiallyOpen";
    GatePositionTypeEnum[GatePositionTypeEnum["Close"] = 3] = "Close";
    GatePositionTypeEnum[GatePositionTypeEnum["On"] = 4] = "On";
    GatePositionTypeEnum[GatePositionTypeEnum["Off"] = 5] = "Off";
})(GatePositionTypeEnum || (GatePositionTypeEnum = {}));
var GatewayPositionDeviceState = (function (_super) {
    __extends(GatewayPositionDeviceState, _super);
    function GatewayPositionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.GatewayPosition;
        _this.Type = nameof(GatewayPositionState);
        _this.Data = state.state;
        return _this;
    }
    return GatewayPositionDeviceState;
}(DeviceState));
export { GatewayPositionDeviceState };
var GatewayPositionState = (function () {
    function GatewayPositionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.PositionType = GatewayPositionTypeEnum.Unknown;
        this.Position = 0;
    }
    return GatewayPositionState;
}());
export { GatewayPositionState };
export var GatewayPositionTypeEnum;
(function (GatewayPositionTypeEnum) {
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["Unknown"] = 0] = "Unknown";
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["Open"] = 1] = "Open";
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["PartiallyOpen"] = 2] = "PartiallyOpen";
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["Close"] = 3] = "Close";
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["On"] = 4] = "On";
    GatewayPositionTypeEnum[GatewayPositionTypeEnum["Off"] = 5] = "Off";
})(GatewayPositionTypeEnum || (GatewayPositionTypeEnum = {}));
var BlindCalibrationDeviceState = (function (_super) {
    __extends(BlindCalibrationDeviceState, _super);
    function BlindCalibrationDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BlindCalibration;
        _this.Type = nameof(BlindCalibrationState);
        _this.Data = state.state;
        return _this;
    }
    return BlindCalibrationDeviceState;
}(DeviceState));
export { BlindCalibrationDeviceState };
var BlindCalibrationState = (function () {
    function BlindCalibrationState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.CalibrationStatus = BlindCalibrationStatusEnum.AutoLernIdle;
    }
    return BlindCalibrationState;
}());
export { BlindCalibrationState };
export var BlindCalibrationStatusEnum;
(function (BlindCalibrationStatusEnum) {
    BlindCalibrationStatusEnum[BlindCalibrationStatusEnum["AutoLernIdle"] = 0] = "AutoLernIdle";
    BlindCalibrationStatusEnum[BlindCalibrationStatusEnum["AutoLernInProgress"] = 1] = "AutoLernInProgress";
    BlindCalibrationStatusEnum[BlindCalibrationStatusEnum["AutoLernSuccessfull"] = 2] = "AutoLernSuccessfull";
    BlindCalibrationStatusEnum[BlindCalibrationStatusEnum["AutoLernCancelled"] = 4] = "AutoLernCancelled";
})(BlindCalibrationStatusEnum || (BlindCalibrationStatusEnum = {}));
var HumiditySensorDeviceState = (function (_super) {
    __extends(HumiditySensorDeviceState, _super);
    function HumiditySensorDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.HumiditySensorState;
        _this.Type = nameof(HumiditySensorState);
        _this.Data = state.state;
        return _this;
    }
    return HumiditySensorDeviceState;
}(DeviceState));
export { HumiditySensorDeviceState };
var HumiditySensorState = (function () {
    function HumiditySensorState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Type = HumidityTypeEnum.AirHumidity;
        this.Humidity = 0;
    }
    return HumiditySensorState;
}());
export { HumiditySensorState };
export var HumidityTypeEnum;
(function (HumidityTypeEnum) {
    HumidityTypeEnum[HumidityTypeEnum["AirHumidity"] = 0] = "AirHumidity";
    HumidityTypeEnum[HumidityTypeEnum["InsideHumidity"] = 1] = "InsideHumidity";
    HumidityTypeEnum[HumidityTypeEnum["OutsideHumidity"] = 2] = "OutsideHumidity";
    HumidityTypeEnum[HumidityTypeEnum["SafetyHumidity"] = 3] = "SafetyHumidity";
    HumidityTypeEnum[HumidityTypeEnum["SetHumidity"] = 4] = "SetHumidity";
})(HumidityTypeEnum || (HumidityTypeEnum = {}));
var VibrationSensorDeviceState = (function (_super) {
    __extends(VibrationSensorDeviceState, _super);
    function VibrationSensorDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.VibrationSensorState;
        _this.Type = nameof(VibrationSensorState);
        _this.Data = state.state;
        return _this;
    }
    return VibrationSensorDeviceState;
}(DeviceState));
export { VibrationSensorDeviceState };
var VibrationSensorState = (function () {
    function VibrationSensorState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Vibration = VibrationTypeEnum.No;
        this.Acceleration_X = 0;
        this.Acceleration_Y = 0;
        this.Acceleration_Z = 0;
        this.AccelerationModule = 0;
    }
    return VibrationSensorState;
}());
export { VibrationSensorState };
export var VibrationTypeEnum;
(function (VibrationTypeEnum) {
    VibrationTypeEnum[VibrationTypeEnum["No"] = 0] = "No";
    VibrationTypeEnum[VibrationTypeEnum["Yes"] = 1] = "Yes";
})(VibrationTypeEnum || (VibrationTypeEnum = {}));
var BinarySensorStateDeviceState = (function (_super) {
    __extends(BinarySensorStateDeviceState, _super);
    function BinarySensorStateDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BinarySensorState;
        _this.Type = nameof(BinarySensorState);
        _this.Data = state.state;
        return _this;
    }
    return BinarySensorStateDeviceState;
}(DeviceState));
export { BinarySensorStateDeviceState };
var BinarySensorState = (function () {
    function BinarySensorState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.State = BinarySensorStateEnum.Low;
    }
    return BinarySensorState;
}());
export { BinarySensorState };
export var BinarySensorStateEnum;
(function (BinarySensorStateEnum) {
    BinarySensorStateEnum[BinarySensorStateEnum["High"] = 1] = "High";
    BinarySensorStateEnum[BinarySensorStateEnum["Low"] = 0] = "Low";
})(BinarySensorStateEnum || (BinarySensorStateEnum = {}));
var ConfigurationDeviceState = (function (_super) {
    __extends(ConfigurationDeviceState, _super);
    function ConfigurationDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.ConfigurationState;
        _this.Type = nameof(ConfigurationState);
        _this.Data = state.state;
        return _this;
    }
    return ConfigurationDeviceState;
}(DeviceState));
export { ConfigurationDeviceState };
var ConfigurationState = (function () {
    function ConfigurationState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Configuration = ConfigurationStateEnum.Unknown;
    }
    return ConfigurationState;
}());
export { ConfigurationState };
export var ConfigurationStateEnum;
(function (ConfigurationStateEnum) {
    ConfigurationStateEnum[ConfigurationStateEnum["Unknown"] = 0] = "Unknown";
    ConfigurationStateEnum[ConfigurationStateEnum["OngoingConfiguration"] = 1] = "OngoingConfiguration";
    ConfigurationStateEnum[ConfigurationStateEnum["NotConfigured"] = 2] = "NotConfigured";
    ConfigurationStateEnum[ConfigurationStateEnum["Configured"] = 3] = "Configured";
    ConfigurationStateEnum[ConfigurationStateEnum["PartiallyConfigured"] = 4] = "PartiallyConfigured";
})(ConfigurationStateEnum || (ConfigurationStateEnum = {}));
var BlindOpenCloseTimeDeviceState = (function (_super) {
    __extends(BlindOpenCloseTimeDeviceState, _super);
    function BlindOpenCloseTimeDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.BlindOpenCloseTime;
        _this.Type = nameof(BlindOpenCloseTimeState);
        _this.Data = state.state;
        return _this;
    }
    return BlindOpenCloseTimeDeviceState;
}(DeviceState));
export { BlindOpenCloseTimeDeviceState };
var BlindOpenCloseTimeState = (function () {
    function BlindOpenCloseTimeState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Vibration = VibrationTypeEnum.No;
        this.CloseTime = 0;
        this.OpenTime = 0;
        this.HallCounter = 0;
    }
    return BlindOpenCloseTimeState;
}());
export { BlindOpenCloseTimeState };
var OvercurrentProtectionDeviceState = (function (_super) {
    __extends(OvercurrentProtectionDeviceState, _super);
    function OvercurrentProtectionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.OvercurrentProtectionState;
        _this.Type = nameof(OvercurrentProtectionState);
        _this.Data = state.state;
        return _this;
    }
    return OvercurrentProtectionDeviceState;
}(DeviceState));
export { OvercurrentProtectionDeviceState };
var OvercurrentProtectionState = (function () {
    function OvercurrentProtectionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Triggered = false;
    }
    return OvercurrentProtectionState;
}());
export { OvercurrentProtectionState };
var OvercurrentProtectionThresholdDeviceState = (function (_super) {
    __extends(OvercurrentProtectionThresholdDeviceState, _super);
    function OvercurrentProtectionThresholdDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.OvercurrentProtectionThreshold;
        _this.Type = nameof(OvercurrentProtectionThresholdState);
        _this.Data = state.state;
        return _this;
    }
    return OvercurrentProtectionThresholdDeviceState;
}(DeviceState));
export { OvercurrentProtectionThresholdDeviceState };
var OvercurrentProtectionThresholdState = (function () {
    function OvercurrentProtectionThresholdState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Current = 0;
    }
    return OvercurrentProtectionThresholdState;
}());
export { OvercurrentProtectionThresholdState };
var FacadePositionDeviceState = (function (_super) {
    __extends(FacadePositionDeviceState, _super);
    function FacadePositionDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.FacadePosition;
        _this.Type = nameof(FacadePositionState);
        _this.Data = state.state;
        return _this;
    }
    return FacadePositionDeviceState;
}(DeviceState));
export { FacadePositionDeviceState };
var FacadePositionState = (function () {
    function FacadePositionState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Position = 0;
        this.Tilt = 0;
    }
    return FacadePositionState;
}());
export { FacadePositionState };
var CurrentWindThresholdDeviceState = (function (_super) {
    __extends(CurrentWindThresholdDeviceState, _super);
    function CurrentWindThresholdDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.CurrentWindThreshold;
        _this.Type = nameof(CurrentWindThresholdState);
        _this.Data = state.state;
        return _this;
    }
    return CurrentWindThresholdDeviceState;
}(DeviceState));
export { CurrentWindThresholdDeviceState };
var CurrentWindThresholdState = (function () {
    function CurrentWindThresholdState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.WindThreshold = WindThresholdStateEnum.Unknown;
    }
    return CurrentWindThresholdState;
}());
export { CurrentWindThresholdState };
export var WindThresholdStateEnum;
(function (WindThresholdStateEnum) {
    WindThresholdStateEnum[WindThresholdStateEnum["Unknown"] = 0] = "Unknown";
    WindThresholdStateEnum[WindThresholdStateEnum["Below"] = 1] = "Below";
    WindThresholdStateEnum[WindThresholdStateEnum["Exceeded"] = 2] = "Exceeded";
    WindThresholdStateEnum[WindThresholdStateEnum["Inactive"] = 3] = "Inactive";
})(WindThresholdStateEnum || (WindThresholdStateEnum = {}));
var CurrentLightThresholdDeviceState = (function (_super) {
    __extends(CurrentLightThresholdDeviceState, _super);
    function CurrentLightThresholdDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.CurrentWindThreshold;
        _this.Type = nameof(CurrentLightThresholdState);
        _this.Data = state.state;
        return _this;
    }
    return CurrentLightThresholdDeviceState;
}(DeviceState));
export { CurrentLightThresholdDeviceState };
var CurrentLightThresholdState = (function () {
    function CurrentLightThresholdState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.LightThreshold = LightThresholdStateEnum.Unknown;
        this.Value = 0;
    }
    return CurrentLightThresholdState;
}());
export { CurrentLightThresholdState };
export var LightThresholdStateEnum;
(function (LightThresholdStateEnum) {
    LightThresholdStateEnum[LightThresholdStateEnum["Unknown"] = 0] = "Unknown";
    LightThresholdStateEnum[LightThresholdStateEnum["Below"] = 1] = "Below";
    LightThresholdStateEnum[LightThresholdStateEnum["Exceeded"] = 2] = "Exceeded";
})(LightThresholdStateEnum || (LightThresholdStateEnum = {}));
var WindSpeedDeviceState = (function (_super) {
    __extends(WindSpeedDeviceState, _super);
    function WindSpeedDeviceState(state) {
        var _this = _super.call(this) || this;
        _this.TypeAsEnum = DeviceResponseType.WindSpeedState;
        _this.Type = nameof(WindSpeedState);
        _this.Data = state.state;
        return _this;
    }
    return WindSpeedDeviceState;
}(DeviceState));
export { WindSpeedDeviceState };
var WindSpeedState = (function () {
    function WindSpeedState() {
        this.Channel = 0;
        this.StateReliability = StateReliability.Unconfident;
        this.Value = 0;
    }
    return WindSpeedState;
}());
export { WindSpeedState };
//# sourceMappingURL=IDeviceState.js.map