import { IDIService } from "../../IDIService";
import { ITypedEvent } from "../../TypedEvent";
import { DeviceTasksInfo, IDevice } from './IDevice';
import { IDeviceState } from './IDeviceState';
export interface IDevicesService extends IDIService {
    OnDeviceRegisteredEvent(): ITypedEvent<IDevice>;
    OnDeviceRemovedEvent(): ITypedEvent<IDevice>;
    OnDeviceFoundEvent(): ITypedEvent<IDevice>;
    OnDeviceStateChangedEvent(): ITypedEvent<[IDevice, IDeviceState<any>]>;
    OnDevicesTasksExecutionChangeEvent(): ITypedEvent<DeviceTasksInfo[]>;
    GetDevicesAsync(): Promise<IDevice[]>;
    SyncDevicesStatesAsync(): Promise<boolean>;
    GetDevice(guid: string): IDevice | undefined;
    FindDevicesAsync(): Promise<void>;
    StopSearchingForDevices(): Promise<void>;
    RegisterDeviceAsync(device: IDevice): Promise<void>;
    RemoveDeviceAsync(device: IDevice): Promise<void>;
}
