import { IDIService } from "./../../IDIService";
export interface ILoggerService extends IDIService {
    get LogLevel(): LogLevel;
    set LogLevel(level: LogLevel);
    Warning(message: string): void;
    Warning<T extends Object>(contextClassType: new (...params: any[]) => T | string, message: string): void;
    Error(message: string): void;
    Error<T extends Object>(contextClassType: {
        new (...params: any[]): T;
    } | string, message: string): void;
    Info(message: string): void;
    Info<T extends Object>(contextClassType: {
        new (...params: any[]): T;
    } | string, message: string): void;
    Debug(message: string): void;
    Debug<T extends Object>(contextClassType: {
        new (...params: any[]): T;
    } | string, message: string): void;
    Log(message: string): void;
    Log<T extends Object>(contextClassType: {
        new (...params: any[]): T;
    } | string, message: string): void;
}
export declare enum LogLevel {
    Debug = 0,
    Info = 1,
    Warning = 2,
    Error = 3
}
